// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:msg/Grasp.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/msg/grasp.hpp"


#ifndef RC_REASON_MSGS__MSG__DETAIL__GRASP__TRAITS_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__GRASP__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/msg/detail/grasp__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__traits.hpp"

namespace rc_reason_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Grasp & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: uuid
  {
    out << "uuid: ";
    rosidl_generator_traits::value_to_yaml(msg.uuid, out);
    out << ", ";
  }

  // member: match_uuid
  {
    out << "match_uuid: ";
    rosidl_generator_traits::value_to_yaml(msg.match_uuid, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
    out << ", ";
  }

  // member: priority
  {
    out << "priority: ";
    rosidl_generator_traits::value_to_yaml(msg.priority, out);
    out << ", ";
  }

  // member: gripper_id
  {
    out << "gripper_id: ";
    rosidl_generator_traits::value_to_yaml(msg.gripper_id, out);
    out << ", ";
  }

  // member: collision_checked
  {
    out << "collision_checked: ";
    rosidl_generator_traits::value_to_yaml(msg.collision_checked, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Grasp & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: uuid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "uuid: ";
    rosidl_generator_traits::value_to_yaml(msg.uuid, out);
    out << "\n";
  }

  // member: match_uuid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "match_uuid: ";
    rosidl_generator_traits::value_to_yaml(msg.match_uuid, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }

  // member: priority
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "priority: ";
    rosidl_generator_traits::value_to_yaml(msg.priority, out);
    out << "\n";
  }

  // member: gripper_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gripper_id: ";
    rosidl_generator_traits::value_to_yaml(msg.gripper_id, out);
    out << "\n";
  }

  // member: collision_checked
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "collision_checked: ";
    rosidl_generator_traits::value_to_yaml(msg.collision_checked, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Grasp & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::msg::Grasp & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::msg::Grasp & msg)
{
  return rc_reason_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::msg::Grasp>()
{
  return "rc_reason_msgs::msg::Grasp";
}

template<>
inline const char * name<rc_reason_msgs::msg::Grasp>()
{
  return "rc_reason_msgs/msg/Grasp";
}

template<>
struct has_fixed_size<rc_reason_msgs::msg::Grasp>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::msg::Grasp>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::msg::Grasp>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__MSG__DETAIL__GRASP__TRAITS_HPP_
