// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/Item.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/msg/item.hpp"


#ifndef RC_REASON_MSGS__MSG__DETAIL__ITEM__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__ITEM__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'rectangle'
#include "rc_reason_msgs/msg/detail/rectangle__struct.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__Item __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__Item __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Item_
{
  using Type = Item_<ContainerAllocator>;

  explicit Item_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : rectangle(_init),
    pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->uuid = "";
      this->type = "";
    }
  }

  explicit Item_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : uuid(_alloc),
    type(_alloc),
    rectangle(_alloc, _init),
    pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->uuid = "";
      this->type = "";
    }
  }

  // field types and members
  using _uuid_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _uuid_type uuid;
  using _grasp_uuids_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _grasp_uuids_type grasp_uuids;
  using _type_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _type_type type;
  using _rectangle_type =
    rc_reason_msgs::msg::Rectangle_<ContainerAllocator>;
  _rectangle_type rectangle;
  using _pose_type =
    geometry_msgs::msg::PoseStamped_<ContainerAllocator>;
  _pose_type pose;

  // setters for named parameter idiom
  Type & set__uuid(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->uuid = _arg;
    return *this;
  }
  Type & set__grasp_uuids(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->grasp_uuids = _arg;
    return *this;
  }
  Type & set__type(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__rectangle(
    const rc_reason_msgs::msg::Rectangle_<ContainerAllocator> & _arg)
  {
    this->rectangle = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::PoseStamped_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }

  // constant declarations
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> RECTANGLE;

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::Item_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::Item_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::Item_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::Item_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::Item_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::Item_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::Item_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::Item_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::Item_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::Item_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__Item
    std::shared_ptr<rc_reason_msgs::msg::Item_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__Item
    std::shared_ptr<rc_reason_msgs::msg::Item_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Item_ & other) const
  {
    if (this->uuid != other.uuid) {
      return false;
    }
    if (this->grasp_uuids != other.grasp_uuids) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->rectangle != other.rectangle) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const Item_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Item_

// alias to use template instance with default allocator
using Item =
  rc_reason_msgs::msg::Item_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Item_<ContainerAllocator>::RECTANGLE = "RECTANGLE";

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__DETAIL__ITEM__STRUCT_HPP_
