// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:msg/SuctionGrasp.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/msg/suction_grasp.hpp"


#ifndef RC_REASON_MSGS__MSG__DETAIL__SUCTION_GRASP__TRAITS_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__SUCTION_GRASP__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/msg/detail/suction_grasp__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__traits.hpp"

namespace rc_reason_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SuctionGrasp & msg,
  std::ostream & out)
{
  out << "{";
  // member: uuid
  {
    out << "uuid: ";
    rosidl_generator_traits::value_to_yaml(msg.uuid, out);
    out << ", ";
  }

  // member: item_uuid
  {
    out << "item_uuid: ";
    rosidl_generator_traits::value_to_yaml(msg.item_uuid, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
    out << ", ";
  }

  // member: quality
  {
    out << "quality: ";
    rosidl_generator_traits::value_to_yaml(msg.quality, out);
    out << ", ";
  }

  // member: max_suction_surface_length
  {
    out << "max_suction_surface_length: ";
    rosidl_generator_traits::value_to_yaml(msg.max_suction_surface_length, out);
    out << ", ";
  }

  // member: max_suction_surface_width
  {
    out << "max_suction_surface_width: ";
    rosidl_generator_traits::value_to_yaml(msg.max_suction_surface_width, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SuctionGrasp & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: uuid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "uuid: ";
    rosidl_generator_traits::value_to_yaml(msg.uuid, out);
    out << "\n";
  }

  // member: item_uuid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "item_uuid: ";
    rosidl_generator_traits::value_to_yaml(msg.item_uuid, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }

  // member: quality
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "quality: ";
    rosidl_generator_traits::value_to_yaml(msg.quality, out);
    out << "\n";
  }

  // member: max_suction_surface_length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_suction_surface_length: ";
    rosidl_generator_traits::value_to_yaml(msg.max_suction_surface_length, out);
    out << "\n";
  }

  // member: max_suction_surface_width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_suction_surface_width: ";
    rosidl_generator_traits::value_to_yaml(msg.max_suction_surface_width, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SuctionGrasp & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::msg::SuctionGrasp & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::msg::SuctionGrasp & msg)
{
  return rc_reason_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::msg::SuctionGrasp>()
{
  return "rc_reason_msgs::msg::SuctionGrasp";
}

template<>
inline const char * name<rc_reason_msgs::msg::SuctionGrasp>()
{
  return "rc_reason_msgs/msg/SuctionGrasp";
}

template<>
struct has_fixed_size<rc_reason_msgs::msg::SuctionGrasp>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::msg::SuctionGrasp>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::msg::SuctionGrasp>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__MSG__DETAIL__SUCTION_GRASP__TRAITS_HPP_
