// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from rc_reason_msgs:srv/DetectTags.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "rc_reason_msgs/srv/detail/detect_tags__functions.h"
#include "rc_reason_msgs/srv/detail/detect_tags__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rc_reason_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void DetectTags_Request_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rc_reason_msgs::srv::DetectTags_Request(_init);
}

void DetectTags_Request_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rc_reason_msgs::srv::DetectTags_Request *>(message_memory);
  typed_message->~DetectTags_Request();
}

size_t size_function__DetectTags_Request__tags(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<rc_reason_msgs::msg::Tag> *>(untyped_member);
  return member->size();
}

const void * get_const_function__DetectTags_Request__tags(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<rc_reason_msgs::msg::Tag> *>(untyped_member);
  return &member[index];
}

void * get_function__DetectTags_Request__tags(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<rc_reason_msgs::msg::Tag> *>(untyped_member);
  return &member[index];
}

void fetch_function__DetectTags_Request__tags(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const rc_reason_msgs::msg::Tag *>(
    get_const_function__DetectTags_Request__tags(untyped_member, index));
  auto & value = *reinterpret_cast<rc_reason_msgs::msg::Tag *>(untyped_value);
  value = item;
}

void assign_function__DetectTags_Request__tags(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<rc_reason_msgs::msg::Tag *>(
    get_function__DetectTags_Request__tags(untyped_member, index));
  const auto & value = *reinterpret_cast<const rc_reason_msgs::msg::Tag *>(untyped_value);
  item = value;
}

void resize_function__DetectTags_Request__tags(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<rc_reason_msgs::msg::Tag> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember DetectTags_Request_message_member_array[3] = {
  {
    "tags",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_reason_msgs::msg::Tag>(),  // members of sub message
    false,  // is key
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectTags_Request, tags),  // bytes offset in struct
    nullptr,  // default value
    size_function__DetectTags_Request__tags,  // size() function pointer
    get_const_function__DetectTags_Request__tags,  // get_const(index) function pointer
    get_function__DetectTags_Request__tags,  // get(index) function pointer
    fetch_function__DetectTags_Request__tags,  // fetch(index, &value) function pointer
    assign_function__DetectTags_Request__tags,  // assign(index, value) function pointer
    resize_function__DetectTags_Request__tags  // resize(index) function pointer
  },
  {
    "pose_frame",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectTags_Request, pose_frame),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "robot_pose",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<geometry_msgs::msg::Pose>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectTags_Request, robot_pose),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers DetectTags_Request_message_members = {
  "rc_reason_msgs::srv",  // message namespace
  "DetectTags_Request",  // message name
  3,  // number of fields
  sizeof(rc_reason_msgs::srv::DetectTags_Request),
  false,  // has_any_key_member_
  DetectTags_Request_message_member_array,  // message members
  DetectTags_Request_init_function,  // function to initialize message memory (memory has to be allocated)
  DetectTags_Request_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t DetectTags_Request_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &DetectTags_Request_message_members,
  get_message_typesupport_handle_function,
  &rc_reason_msgs__srv__DetectTags_Request__get_type_hash,
  &rc_reason_msgs__srv__DetectTags_Request__get_type_description,
  &rc_reason_msgs__srv__DetectTags_Request__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rc_reason_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::srv::DetectTags_Request>()
{
  return &::rc_reason_msgs::srv::rosidl_typesupport_introspection_cpp::DetectTags_Request_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rc_reason_msgs, srv, DetectTags_Request)() {
  return &::rc_reason_msgs::srv::rosidl_typesupport_introspection_cpp::DetectTags_Request_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "array"
// already included above
// #include "cstddef"
// already included above
// #include "string"
// already included above
// #include "vector"
// already included above
// #include "rosidl_runtime_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rc_reason_msgs/srv/detail/detect_tags__functions.h"
// already included above
// #include "rc_reason_msgs/srv/detail/detect_tags__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/field_types.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rc_reason_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void DetectTags_Response_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rc_reason_msgs::srv::DetectTags_Response(_init);
}

void DetectTags_Response_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rc_reason_msgs::srv::DetectTags_Response *>(message_memory);
  typed_message->~DetectTags_Response();
}

size_t size_function__DetectTags_Response__tags(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<rc_reason_msgs::msg::DetectedTag> *>(untyped_member);
  return member->size();
}

const void * get_const_function__DetectTags_Response__tags(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<rc_reason_msgs::msg::DetectedTag> *>(untyped_member);
  return &member[index];
}

void * get_function__DetectTags_Response__tags(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<rc_reason_msgs::msg::DetectedTag> *>(untyped_member);
  return &member[index];
}

void fetch_function__DetectTags_Response__tags(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const rc_reason_msgs::msg::DetectedTag *>(
    get_const_function__DetectTags_Response__tags(untyped_member, index));
  auto & value = *reinterpret_cast<rc_reason_msgs::msg::DetectedTag *>(untyped_value);
  value = item;
}

void assign_function__DetectTags_Response__tags(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<rc_reason_msgs::msg::DetectedTag *>(
    get_function__DetectTags_Response__tags(untyped_member, index));
  const auto & value = *reinterpret_cast<const rc_reason_msgs::msg::DetectedTag *>(untyped_value);
  item = value;
}

void resize_function__DetectTags_Response__tags(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<rc_reason_msgs::msg::DetectedTag> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember DetectTags_Response_message_member_array[3] = {
  {
    "tags",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_reason_msgs::msg::DetectedTag>(),  // members of sub message
    false,  // is key
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectTags_Response, tags),  // bytes offset in struct
    nullptr,  // default value
    size_function__DetectTags_Response__tags,  // size() function pointer
    get_const_function__DetectTags_Response__tags,  // get_const(index) function pointer
    get_function__DetectTags_Response__tags,  // get(index) function pointer
    fetch_function__DetectTags_Response__tags,  // fetch(index, &value) function pointer
    assign_function__DetectTags_Response__tags,  // assign(index, value) function pointer
    resize_function__DetectTags_Response__tags  // resize(index) function pointer
  },
  {
    "timestamp",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<builtin_interfaces::msg::Time>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectTags_Response, timestamp),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "return_code",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_common_msgs::msg::ReturnCode>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectTags_Response, return_code),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers DetectTags_Response_message_members = {
  "rc_reason_msgs::srv",  // message namespace
  "DetectTags_Response",  // message name
  3,  // number of fields
  sizeof(rc_reason_msgs::srv::DetectTags_Response),
  false,  // has_any_key_member_
  DetectTags_Response_message_member_array,  // message members
  DetectTags_Response_init_function,  // function to initialize message memory (memory has to be allocated)
  DetectTags_Response_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t DetectTags_Response_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &DetectTags_Response_message_members,
  get_message_typesupport_handle_function,
  &rc_reason_msgs__srv__DetectTags_Response__get_type_hash,
  &rc_reason_msgs__srv__DetectTags_Response__get_type_description,
  &rc_reason_msgs__srv__DetectTags_Response__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rc_reason_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::srv::DetectTags_Response>()
{
  return &::rc_reason_msgs::srv::rosidl_typesupport_introspection_cpp::DetectTags_Response_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rc_reason_msgs, srv, DetectTags_Response)() {
  return &::rc_reason_msgs::srv::rosidl_typesupport_introspection_cpp::DetectTags_Response_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "array"
// already included above
// #include "cstddef"
// already included above
// #include "string"
// already included above
// #include "vector"
// already included above
// #include "rosidl_runtime_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rc_reason_msgs/srv/detail/detect_tags__functions.h"
// already included above
// #include "rc_reason_msgs/srv/detail/detect_tags__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/field_types.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rc_reason_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void DetectTags_Event_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rc_reason_msgs::srv::DetectTags_Event(_init);
}

void DetectTags_Event_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rc_reason_msgs::srv::DetectTags_Event *>(message_memory);
  typed_message->~DetectTags_Event();
}

size_t size_function__DetectTags_Event__request(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<rc_reason_msgs::srv::DetectTags_Request> *>(untyped_member);
  return member->size();
}

const void * get_const_function__DetectTags_Event__request(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<rc_reason_msgs::srv::DetectTags_Request> *>(untyped_member);
  return &member[index];
}

void * get_function__DetectTags_Event__request(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<rc_reason_msgs::srv::DetectTags_Request> *>(untyped_member);
  return &member[index];
}

void fetch_function__DetectTags_Event__request(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const rc_reason_msgs::srv::DetectTags_Request *>(
    get_const_function__DetectTags_Event__request(untyped_member, index));
  auto & value = *reinterpret_cast<rc_reason_msgs::srv::DetectTags_Request *>(untyped_value);
  value = item;
}

void assign_function__DetectTags_Event__request(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<rc_reason_msgs::srv::DetectTags_Request *>(
    get_function__DetectTags_Event__request(untyped_member, index));
  const auto & value = *reinterpret_cast<const rc_reason_msgs::srv::DetectTags_Request *>(untyped_value);
  item = value;
}

void resize_function__DetectTags_Event__request(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<rc_reason_msgs::srv::DetectTags_Request> *>(untyped_member);
  member->resize(size);
}

size_t size_function__DetectTags_Event__response(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<rc_reason_msgs::srv::DetectTags_Response> *>(untyped_member);
  return member->size();
}

const void * get_const_function__DetectTags_Event__response(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<rc_reason_msgs::srv::DetectTags_Response> *>(untyped_member);
  return &member[index];
}

void * get_function__DetectTags_Event__response(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<rc_reason_msgs::srv::DetectTags_Response> *>(untyped_member);
  return &member[index];
}

void fetch_function__DetectTags_Event__response(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const rc_reason_msgs::srv::DetectTags_Response *>(
    get_const_function__DetectTags_Event__response(untyped_member, index));
  auto & value = *reinterpret_cast<rc_reason_msgs::srv::DetectTags_Response *>(untyped_value);
  value = item;
}

void assign_function__DetectTags_Event__response(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<rc_reason_msgs::srv::DetectTags_Response *>(
    get_function__DetectTags_Event__response(untyped_member, index));
  const auto & value = *reinterpret_cast<const rc_reason_msgs::srv::DetectTags_Response *>(untyped_value);
  item = value;
}

void resize_function__DetectTags_Event__response(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<rc_reason_msgs::srv::DetectTags_Response> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember DetectTags_Event_message_member_array[3] = {
  {
    "info",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<service_msgs::msg::ServiceEventInfo>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectTags_Event, info),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "request",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_reason_msgs::srv::DetectTags_Request>(),  // members of sub message
    false,  // is key
    true,  // is array
    1,  // array size
    true,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectTags_Event, request),  // bytes offset in struct
    nullptr,  // default value
    size_function__DetectTags_Event__request,  // size() function pointer
    get_const_function__DetectTags_Event__request,  // get_const(index) function pointer
    get_function__DetectTags_Event__request,  // get(index) function pointer
    fetch_function__DetectTags_Event__request,  // fetch(index, &value) function pointer
    assign_function__DetectTags_Event__request,  // assign(index, value) function pointer
    resize_function__DetectTags_Event__request  // resize(index) function pointer
  },
  {
    "response",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_reason_msgs::srv::DetectTags_Response>(),  // members of sub message
    false,  // is key
    true,  // is array
    1,  // array size
    true,  // is upper bound
    offsetof(rc_reason_msgs::srv::DetectTags_Event, response),  // bytes offset in struct
    nullptr,  // default value
    size_function__DetectTags_Event__response,  // size() function pointer
    get_const_function__DetectTags_Event__response,  // get_const(index) function pointer
    get_function__DetectTags_Event__response,  // get(index) function pointer
    fetch_function__DetectTags_Event__response,  // fetch(index, &value) function pointer
    assign_function__DetectTags_Event__response,  // assign(index, value) function pointer
    resize_function__DetectTags_Event__response  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers DetectTags_Event_message_members = {
  "rc_reason_msgs::srv",  // message namespace
  "DetectTags_Event",  // message name
  3,  // number of fields
  sizeof(rc_reason_msgs::srv::DetectTags_Event),
  false,  // has_any_key_member_
  DetectTags_Event_message_member_array,  // message members
  DetectTags_Event_init_function,  // function to initialize message memory (memory has to be allocated)
  DetectTags_Event_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t DetectTags_Event_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &DetectTags_Event_message_members,
  get_message_typesupport_handle_function,
  &rc_reason_msgs__srv__DetectTags_Event__get_type_hash,
  &rc_reason_msgs__srv__DetectTags_Event__get_type_description,
  &rc_reason_msgs__srv__DetectTags_Event__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rc_reason_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_reason_msgs::srv::DetectTags_Event>()
{
  return &::rc_reason_msgs::srv::rosidl_typesupport_introspection_cpp::DetectTags_Event_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rc_reason_msgs, srv, DetectTags_Event)() {
  return &::rc_reason_msgs::srv::rosidl_typesupport_introspection_cpp::DetectTags_Event_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"
// already included above
// #include "rc_reason_msgs/srv/detail/detect_tags__functions.h"
// already included above
// #include "rc_reason_msgs/srv/detail/detect_tags__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/service_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/service_type_support_decl.hpp"

namespace rc_reason_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

// this is intentionally not const to allow initialization later to prevent an initialization race
static ::rosidl_typesupport_introspection_cpp::ServiceMembers DetectTags_service_members = {
  "rc_reason_msgs::srv",  // service namespace
  "DetectTags",  // service name
  // the following fields are initialized below on first access
  // see get_service_type_support_handle<rc_reason_msgs::srv::DetectTags>()
  nullptr,  // request message
  nullptr,  // response message
  nullptr,  // event message
};

static const rosidl_service_type_support_t DetectTags_service_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &DetectTags_service_members,
  get_service_typesupport_handle_function,
  ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_reason_msgs::srv::DetectTags_Request>(),
  ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_reason_msgs::srv::DetectTags_Response>(),
  ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_reason_msgs::srv::DetectTags_Event>(),
  &::rosidl_typesupport_cpp::service_create_event_message<rc_reason_msgs::srv::DetectTags>,
  &::rosidl_typesupport_cpp::service_destroy_event_message<rc_reason_msgs::srv::DetectTags>,
  &rc_reason_msgs__srv__DetectTags__get_type_hash,
  &rc_reason_msgs__srv__DetectTags__get_type_description,
  &rc_reason_msgs__srv__DetectTags__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rc_reason_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
get_service_type_support_handle<rc_reason_msgs::srv::DetectTags>()
{
  // get a handle to the value to be returned
  auto service_type_support =
    &::rc_reason_msgs::srv::rosidl_typesupport_introspection_cpp::DetectTags_service_type_support_handle;
  // get a non-const and properly typed version of the data void *
  auto service_members = const_cast<::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
    static_cast<const ::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
      service_type_support->data));
  // make sure all of the service_members are initialized
  // if they are not, initialize them
  if (
    service_members->request_members_ == nullptr ||
    service_members->response_members_ == nullptr ||
    service_members->event_members_ == nullptr)
  {
    // initialize the request_members_ with the static function from the external library
    service_members->request_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::rc_reason_msgs::srv::DetectTags_Request
      >()->data
      );
    // initialize the response_members_ with the static function from the external library
    service_members->response_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::rc_reason_msgs::srv::DetectTags_Response
      >()->data
      );
    // initialize the event_members_ with the static function from the external library
    service_members->event_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::rc_reason_msgs::srv::DetectTags_Event
      >()->data
      );
  }
  // finally return the properly initialized service_type_support handle
  return service_type_support;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rc_reason_msgs, srv, DetectTags)() {
  return ::rosidl_typesupport_introspection_cpp::get_service_type_support_handle<rc_reason_msgs::srv::DetectTags>();
}

#ifdef __cplusplus
}
#endif
