// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:srv/SilhouetteMatchDetectObject.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/srv/silhouette_match_detect_object.hpp"


#ifndef RC_REASON_MSGS__SRV__DETAIL__SILHOUETTE_MATCH_DETECT_OBJECT__STRUCT_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__SILHOUETTE_MATCH_DETECT_OBJECT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'object_to_detect'
#include "rc_reason_msgs/msg/detail/silhouette_match_object__struct.hpp"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"
// Member 'collision_detection'
#include "rc_reason_msgs/msg/detail/collision_detection__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SilhouetteMatchDetectObject_Request_
{
  using Type = SilhouetteMatchDetectObject_Request_<ContainerAllocator>;

  explicit SilhouetteMatchDetectObject_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : object_to_detect(_init),
    robot_pose(_init),
    collision_detection(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->offset = 0.0;
      this->pose_frame = "";
      this->load_carrier_id = "";
      this->object_plane_detection = false;
    }
  }

  explicit SilhouetteMatchDetectObject_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : object_to_detect(_alloc, _init),
    pose_frame(_alloc),
    robot_pose(_alloc, _init),
    load_carrier_id(_alloc),
    collision_detection(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->offset = 0.0;
      this->pose_frame = "";
      this->load_carrier_id = "";
      this->object_plane_detection = false;
    }
  }

  // field types and members
  using _object_to_detect_type =
    rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator>;
  _object_to_detect_type object_to_detect;
  using _offset_type =
    double;
  _offset_type offset;
  using _pose_frame_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _pose_frame_type pose_frame;
  using _robot_pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _robot_pose_type robot_pose;
  using _load_carrier_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _load_carrier_id_type load_carrier_id;
  using _collision_detection_type =
    rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator>;
  _collision_detection_type collision_detection;
  using _object_plane_detection_type =
    bool;
  _object_plane_detection_type object_plane_detection;

  // setters for named parameter idiom
  Type & set__object_to_detect(
    const rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator> & _arg)
  {
    this->object_to_detect = _arg;
    return *this;
  }
  Type & set__offset(
    const double & _arg)
  {
    this->offset = _arg;
    return *this;
  }
  Type & set__pose_frame(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->pose_frame = _arg;
    return *this;
  }
  Type & set__robot_pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->robot_pose = _arg;
    return *this;
  }
  Type & set__load_carrier_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->load_carrier_id = _arg;
    return *this;
  }
  Type & set__collision_detection(
    const rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator> & _arg)
  {
    this->collision_detection = _arg;
    return *this;
  }
  Type & set__object_plane_detection(
    const bool & _arg)
  {
    this->object_plane_detection = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SilhouetteMatchDetectObject_Request_ & other) const
  {
    if (this->object_to_detect != other.object_to_detect) {
      return false;
    }
    if (this->offset != other.offset) {
      return false;
    }
    if (this->pose_frame != other.pose_frame) {
      return false;
    }
    if (this->robot_pose != other.robot_pose) {
      return false;
    }
    if (this->load_carrier_id != other.load_carrier_id) {
      return false;
    }
    if (this->collision_detection != other.collision_detection) {
      return false;
    }
    if (this->object_plane_detection != other.object_plane_detection) {
      return false;
    }
    return true;
  }
  bool operator!=(const SilhouetteMatchDetectObject_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SilhouetteMatchDetectObject_Request_

// alias to use template instance with default allocator
using SilhouetteMatchDetectObject_Request =
  rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs


// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"
// Member 'matches'
#include "rc_reason_msgs/msg/detail/match__struct.hpp"
// Member 'grasps'
#include "rc_reason_msgs/msg/detail/grasp__struct.hpp"
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier__struct.hpp"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SilhouetteMatchDetectObject_Response_
{
  using Type = SilhouetteMatchDetectObject_Response_<ContainerAllocator>;

  explicit SilhouetteMatchDetectObject_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_init),
    return_code(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->object_id = "";
    }
  }

  explicit SilhouetteMatchDetectObject_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_alloc, _init),
    object_id(_alloc),
    return_code(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->object_id = "";
    }
  }

  // field types and members
  using _timestamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _timestamp_type timestamp;
  using _object_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _object_id_type object_id;
  using _matches_type =
    std::vector<rc_reason_msgs::msg::Match_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::Match_<ContainerAllocator>>>;
  _matches_type matches;
  using _grasps_type =
    std::vector<rc_reason_msgs::msg::Grasp_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::Grasp_<ContainerAllocator>>>;
  _grasps_type grasps;
  using _load_carriers_type =
    std::vector<rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>>>;
  _load_carriers_type load_carriers;
  using _return_code_type =
    rc_common_msgs::msg::ReturnCode_<ContainerAllocator>;
  _return_code_type return_code;

  // setters for named parameter idiom
  Type & set__timestamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__object_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->object_id = _arg;
    return *this;
  }
  Type & set__matches(
    const std::vector<rc_reason_msgs::msg::Match_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::Match_<ContainerAllocator>>> & _arg)
  {
    this->matches = _arg;
    return *this;
  }
  Type & set__grasps(
    const std::vector<rc_reason_msgs::msg::Grasp_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::Grasp_<ContainerAllocator>>> & _arg)
  {
    this->grasps = _arg;
    return *this;
  }
  Type & set__load_carriers(
    const std::vector<rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>>> & _arg)
  {
    this->load_carriers = _arg;
    return *this;
  }
  Type & set__return_code(
    const rc_common_msgs::msg::ReturnCode_<ContainerAllocator> & _arg)
  {
    this->return_code = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SilhouetteMatchDetectObject_Response_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->object_id != other.object_id) {
      return false;
    }
    if (this->matches != other.matches) {
      return false;
    }
    if (this->grasps != other.grasps) {
      return false;
    }
    if (this->load_carriers != other.load_carriers) {
      return false;
    }
    if (this->return_code != other.return_code) {
      return false;
    }
    return true;
  }
  bool operator!=(const SilhouetteMatchDetectObject_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SilhouetteMatchDetectObject_Response_

// alias to use template instance with default allocator
using SilhouetteMatchDetectObject_Response =
  rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Event __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Event __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SilhouetteMatchDetectObject_Event_
{
  using Type = SilhouetteMatchDetectObject_Event_<ContainerAllocator>;

  explicit SilhouetteMatchDetectObject_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit SilhouetteMatchDetectObject_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Event
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Event
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SilhouetteMatchDetectObject_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const SilhouetteMatchDetectObject_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SilhouetteMatchDetectObject_Event_

// alias to use template instance with default allocator
using SilhouetteMatchDetectObject_Event =
  rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{

namespace srv
{

struct SilhouetteMatchDetectObject
{
  using Request = rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request;
  using Response = rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response;
  using Event = rc_reason_msgs::srv::SilhouetteMatchDetectObject_Event;
};

}  // namespace srv

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__DETAIL__SILHOUETTE_MATCH_DETECT_OBJECT__STRUCT_HPP_
