// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:msg/CellFillingLevel.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/msg/cell_filling_level.hpp"


#ifndef RC_REASON_MSGS__MSG__DETAIL__CELL_FILLING_LEVEL__TRAITS_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__CELL_FILLING_LEVEL__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/msg/detail/cell_filling_level__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'cell_size'
#include "rc_reason_msgs/msg/detail/rectangle__traits.hpp"
// Member 'cell_position'
#include "geometry_msgs/msg/detail/point__traits.hpp"
// Member 'level_in_percent'
// Member 'level_free_in_meters'
#include "rc_reason_msgs/msg/detail/range_value__traits.hpp"

namespace rc_reason_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const CellFillingLevel & msg,
  std::ostream & out)
{
  out << "{";
  // member: cell_size
  {
    out << "cell_size: ";
    to_flow_style_yaml(msg.cell_size, out);
    out << ", ";
  }

  // member: cell_position
  {
    out << "cell_position: ";
    to_flow_style_yaml(msg.cell_position, out);
    out << ", ";
  }

  // member: level_in_percent
  {
    out << "level_in_percent: ";
    to_flow_style_yaml(msg.level_in_percent, out);
    out << ", ";
  }

  // member: level_free_in_meters
  {
    out << "level_free_in_meters: ";
    to_flow_style_yaml(msg.level_free_in_meters, out);
    out << ", ";
  }

  // member: coverage
  {
    out << "coverage: ";
    rosidl_generator_traits::value_to_yaml(msg.coverage, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CellFillingLevel & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: cell_size
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cell_size:\n";
    to_block_style_yaml(msg.cell_size, out, indentation + 2);
  }

  // member: cell_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cell_position:\n";
    to_block_style_yaml(msg.cell_position, out, indentation + 2);
  }

  // member: level_in_percent
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "level_in_percent:\n";
    to_block_style_yaml(msg.level_in_percent, out, indentation + 2);
  }

  // member: level_free_in_meters
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "level_free_in_meters:\n";
    to_block_style_yaml(msg.level_free_in_meters, out, indentation + 2);
  }

  // member: coverage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "coverage: ";
    rosidl_generator_traits::value_to_yaml(msg.coverage, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CellFillingLevel & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::msg::CellFillingLevel & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::msg::CellFillingLevel & msg)
{
  return rc_reason_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::msg::CellFillingLevel>()
{
  return "rc_reason_msgs::msg::CellFillingLevel";
}

template<>
inline const char * name<rc_reason_msgs::msg::CellFillingLevel>()
{
  return "rc_reason_msgs/msg/CellFillingLevel";
}

template<>
struct has_fixed_size<rc_reason_msgs::msg::CellFillingLevel>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Point>::value && has_fixed_size<rc_reason_msgs::msg::RangeValue>::value && has_fixed_size<rc_reason_msgs::msg::Rectangle>::value> {};

template<>
struct has_bounded_size<rc_reason_msgs::msg::CellFillingLevel>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Point>::value && has_bounded_size<rc_reason_msgs::msg::RangeValue>::value && has_bounded_size<rc_reason_msgs::msg::Rectangle>::value> {};

template<>
struct is_message<rc_reason_msgs::msg::CellFillingLevel>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__MSG__DETAIL__CELL_FILLING_LEVEL__TRAITS_HPP_
