// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/SetHandEyeCalibrationPose.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_reason_msgs/srv/set_hand_eye_calibration_pose.h"


#ifndef RC_REASON_MSGS__SRV__DETAIL__SET_HAND_EYE_CALIBRATION_POSE__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__SET_HAND_EYE_CALIBRATION_POSE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in srv/SetHandEyeCalibrationPose in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__SetHandEyeCalibrationPose_Request
{
  int32_t slot;
  geometry_msgs__msg__Pose pose;
} rc_reason_msgs__srv__SetHandEyeCalibrationPose_Request;

// Struct for a sequence of rc_reason_msgs__srv__SetHandEyeCalibrationPose_Request.
typedef struct rc_reason_msgs__srv__SetHandEyeCalibrationPose_Request__Sequence
{
  rc_reason_msgs__srv__SetHandEyeCalibrationPose_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__SetHandEyeCalibrationPose_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'message'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/SetHandEyeCalibrationPose in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__SetHandEyeCalibrationPose_Response
{
  bool success;
  /// Internal status:
  /// 1: Grid detected, pose stored
  /// 3: Grid detected, pose stored. Ready to calibrate
  /// 4: Insufficient detection of the calibration pattern
  /// 8: No image data available
  /// 12: Invalid orientation given (0,0,0)
  int32_t status;
  /// Human readable message, for development
  rosidl_runtime_c__String message;
} rc_reason_msgs__srv__SetHandEyeCalibrationPose_Response;

// Struct for a sequence of rc_reason_msgs__srv__SetHandEyeCalibrationPose_Response.
typedef struct rc_reason_msgs__srv__SetHandEyeCalibrationPose_Response__Sequence
{
  rc_reason_msgs__srv__SetHandEyeCalibrationPose_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__SetHandEyeCalibrationPose_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  rc_reason_msgs__srv__SetHandEyeCalibrationPose_Event__request__MAX_SIZE = 1
};
// response
enum
{
  rc_reason_msgs__srv__SetHandEyeCalibrationPose_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/SetHandEyeCalibrationPose in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__SetHandEyeCalibrationPose_Event
{
  service_msgs__msg__ServiceEventInfo info;
  rc_reason_msgs__srv__SetHandEyeCalibrationPose_Request__Sequence request;
  rc_reason_msgs__srv__SetHandEyeCalibrationPose_Response__Sequence response;
} rc_reason_msgs__srv__SetHandEyeCalibrationPose_Event;

// Struct for a sequence of rc_reason_msgs__srv__SetHandEyeCalibrationPose_Event.
typedef struct rc_reason_msgs__srv__SetHandEyeCalibrationPose_Event__Sequence
{
  rc_reason_msgs__srv__SetHandEyeCalibrationPose_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__SetHandEyeCalibrationPose_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__SET_HAND_EYE_CALIBRATION_POSE__STRUCT_H_
